<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76977 "21:22:57"))'</do-it>



<class>
<name>ChemoJunDialog</name>
<environment>ChemoJun</environment>
<super>Jun.JunDialog</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Goodies-UI</category>
<attributes>
<package>ChemoJun-Goodies-UI</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunDialog class</class-id> <category>copyright</category>

<body package="ChemoJun-Goodies-UI" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Goodies-UI" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Goodies-UI" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunDialog class</class-id> <category>interface specs</category>

<body package="ChemoJun-Goodies-UI" selector="emptySpec">emptySpec
	"Tools.UIPainter new openOnClass: self andSelector: #emptySpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: ' ' 
			#min: #(#{Core.Point} 20 20 ) 
			#max: #(#{Core.Point} 1280 1024 ) 
			#bounds: #(#{Graphics.Rectangle} 512 384 862 423 ) 
			#isEventDriven: true ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #() ) )</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunDialog</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunDialog</class-id> <category>utility</category>

<body package="ChemoJun-Goodies-UI" selector="chooseMultiple:fromList:values:initialSelections:buttons:values:lines:cancel:for:">chooseMultiple: messageString fromList: list values: listValues initialSelections: initialSelections buttons: buttons values: buttonValues lines: maxLines cancel: cancelBlock for: aVisualOrNil 
	"ChemoJunDialog new
		chooseMultiple: 'Which ones do you want?'
		fromList: #('first' 'second' 'third' 'fourth') values: #(10 20 30 40)
		initialSelections: #('first' 'third')
		buttons: #() values: #()
		lines: 8
		cancel: [#noChoice]
		for: Dialog defaultParentWindow"

	| result spec okValue sequence wrappers listW |
	wrappers := OrderedCollection new.
	result := ValueHolder new.
	sequence := MultiSelectionInList new.
	sequence list: list.
	sequence selections: initialSelections.
	list size = 1 ifTrue: [sequence selections: (Set with: 1)].
	spec := self class interfaceSpecFor: #emptySpec.
	okValue := Object new.
	self initializeBuilderFor: aVisualOrNil.
	builder add: spec window.
	builder add: spec component.
	self initializeWindowFor: aVisualOrNil.
	self setInitialGap.
	self addMessage: messageString centered: true.
	self addGap: 8.
	listW := self 
				addMultiList: sequence
				lines: (maxLines min: list size + 2)
				validation: [true].
	self addGap: 4.
	wrappers add: (self addOK: [sequence selectionIndex ~= 0]).
	buttons isEmpty 
		ifFalse: 
			[self addGap: 4.
			wrappers add: self addDivider.
			self addGap: 4.
			wrappers add: (self 
						addLabels: buttons
						values: buttonValues
						default: okValue
						storeInto: result
						takeKeyboard: true
						equalize: true)].
	self addGap: 6.
	self bottomAlignLowerEdge: listW.
	self bottomAlign: wrappers.
	self preOpen.
	builder openDialogWithExtent: builder window displayBox extent.
	aVisualOrNil notNil 
		ifTrue: 
			[aVisualOrNil 
				invalidateRectangle: aVisualOrNil bounds
				repairNow: true
				forComponent: nil]
		ifFalse: 
			[| parent |
			(parent := Dialog defaultParentWindow) notNil 
				ifTrue: 
					[parent 
						invalidateRectangle: parent bounds
						repairNow: true
						forComponent: nil]].
	^accept value 
		ifTrue: 
			[sequence selectionIndexes asSortedCollection asArray 
				collect: [:i | listValues at: i]]
		ifFalse: [cancel value ifTrue: [cancelBlock value] ifFalse: [result value]]</body>

<body package="ChemoJun-Goodies-UI" selector="chooseMultiple:fromList:values:lines:cancel:">chooseMultiple: messageString fromList: list values: listValues lines: maxLines cancel: cancelBlock 
	"ChemoJunDialog new
		chooseMultiple: 'Which ones do you want?'
		fromList: #('first' 'second' 'third' 'fourth') values: #(10 20 30 40)
		lines: 8
		cancel: [#noChoice]."

	^self 
		chooseMultiple: messageString
		fromList: list
		values: listValues
		buttons: Array new
		values: Array new
		lines: maxLines
		cancel: cancelBlock
		for: Dialog defaultParentWindow</body>
</methods>


</st-source>
