<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76977 "21:22:57"))'</do-it>



<class>
<name>ChemoJunGeneralViewer</name>
<environment>ChemoJun</environment>
<super>ChemoJun.ChemoJunOpenGLDisplayModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Abstract-Objects</category>
<attributes>
<package>ChemoJun-Abstract-Objects</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunGeneralViewer class</class-id> <category>copyright</category>

<body package="ChemoJun-Abstract-Objects" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Abstract-Objects" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Abstract-Objects" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunGeneralViewer class</class-id> <category>interface specs</category>

<body package="ChemoJun-Abstract-Objects" selector="windowSpec">windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	&lt;resource: #canvas&gt;
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 
			#(#UserMessage 
				#key: #jun_Viewfinder 
				#defaultString: 'Viewfinder' ) 
			#min: #(#Point 280 280 ) 
			#bounds: #(#Rectangle 100 100 400 400 ) 
			#flags: 4 
			#menu: #menuBar ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#ArbitraryComponentSpec 
					#layout: #(#LayoutFrame 20 0 1 0 -20 1 -20 1 ) 
					#name: #displayView 
					#colors: 
					#(#LookPreferences 
						#setBackgroundColor: #(#ColorValue #white ) ) 
					#component: #displayView ) 
				#(#ArbitraryComponentSpec 
					#layout: #(#LayoutFrame -19 1 1 0 -1 1 19 0 ) 
					#name: #pickButtonView 
					#flags: 0 
					#component: #pickButtonView ) 
				#(#ArbitraryComponentSpec 
					#layout: #(#LayoutFrame -19 1 20 0 -1 1 38 0 ) 
					#name: #grabButtonView 
					#flags: 0 
					#component: #grabButtonView ) 
				#(#ArbitraryComponentSpec 
					#layout: #(#LayoutFrame -19 1 39 0 -1 1 57 0 ) 
					#name: #dragButtonView 
					#flags: 0 
					#component: #dragButtonView ) 
				#(#ArbitraryComponentSpec 
					#layout: #(#LayoutFrame 1 0 -61 0.5 19 0 61 0.5 ) 
					#name: #xThumbWheelView 
					#flags: 0 
					#component: #xThumbWheelView ) 
				#(#ArbitraryComponentSpec 
					#layout: #(#LayoutFrame -61 0.5 -19 1 61 0.5 -1 1 ) 
					#name: #yThumbWheelView 
					#flags: 0 
					#component: #yThumbWheelView ) 
				#(#ArbitraryComponentSpec 
					#layout: #(#LayoutFrame -19 1 -61 0.5 -1 1 61 0.5 ) 
					#name: #zThumbWheelView 
					#flags: 0 
					#component: #zThumbWheelView ) 
				#(#ArbitraryComponentSpec 
					#layout: #(#LayoutFrame -19 1 62 0.5 -1 1 80 0.5 ) 
					#name: #focusButtonView 
					#flags: 0 
					#component: #focusButtonView ) ) ) )</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunGeneralViewer class</class-id> <category>resources</category>

<body package="ChemoJun-Abstract-Objects" selector="menuBar">menuBar
	"Tools.MenuEditor new openOnClass: self andSelector: #menuBar"

	&lt;resource: #menu&gt;
	^#(#{UI.Menu} #(
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #jun_File 
					#defaultString: 'File' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_as_Image 
								#defaultString: 'Save as Image' ) 
							#value: #saveAsImage ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_as_VRML 
								#defaultString: 'Save as VRML' ) 
							#value: #saveWRL97 ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Quit 
								#defaultString: 'Quit' ) 
							#value: #quitDoing ) ) #(2 1 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_View 
					#defaultString: 'View' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Reset 
								#defaultString: 'Reset' ) 
							#value: #resetView ) ) #(1 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #jun_Misc 
					#defaultString: 'Misc' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Spawn 
								#defaultString: 'Spawn' ) 
							#value: #spawnObject ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Viewport 
								#defaultString: 'Viewport' ) 
							#value: #spawnViewport ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Inspect 
								#defaultString: 'Inspect' ) 
							#value: #inspectModel ) ) #(2 1 ) nil ) ) ) #(3 ) nil ) decodeAsLiteralArray</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunGeneralViewer</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunGeneralViewer</class-id> <category>initialize-release</category>

<body package="ChemoJun-Abstract-Objects" selector="initialize">initialize
	super initialize.
	self useMovementProcess: false</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunGeneralViewer</class-id> <category>accessing</category>

<body package="ChemoJun-Abstract-Objects" selector="exceptHydrogen">exceptHydrogen
	^false</body>

<body package="ChemoJun-Abstract-Objects" selector="exceptIndex">exceptIndex
	^false</body>

<body package="ChemoJun-Abstract-Objects" selector="indexExpression">indexExpression
	| index string |
	index := self class allInstVarNames indexOf: 'indexExpression'.
	index &lt; 1 ifTrue: [^'[]' copy].
	(self instVarAt: index) isNil 
		ifTrue: 
			[string := '[:index :atom | (atom = ''H'') not]' copy.
			self setIndexExpression: string
				setIndexExpressionBlock: (Compiler evaluate: string)].
	^self instVarAt: index</body>

<body package="ChemoJun-Abstract-Objects" selector="indexExpression:">indexExpression: aString 
	| aBlock aBoolean |
	self errorSignal handle: [:exception | aBlock := nil]
		do: 
			[aBlock := Compiler 
						evaluate: aString
						for: self
						logged: false.
			aBoolean := aBlock 
						valueWithArguments: ((Array 
								with: 999
								with: 'H'
								with: 0 , 0 , 0
								with: nil) copyFrom: 1 to: aBlock numArgs).
			(aBoolean isKindOf: Boolean) ifFalse: [self error: 'unexpected error']].
	aBlock isNil ifTrue: [^nil].
	self setIndexExpression: aString setIndexExpressionBlock: aBlock</body>

<body package="ChemoJun-Abstract-Objects" selector="indexExpressionBlock">indexExpressionBlock
	| index |
	index := self class allInstVarNames indexOf: 'indexExpressionBlock'.
	index &lt; 1 ifTrue: [^[] yourself].
	(self instVarAt: index) isNil ifTrue: [self indexExpression].
	^self instVarAt: index</body>

<body package="ChemoJun-Abstract-Objects" selector="moleculeObject">moleculeObject
	^nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunGeneralViewer</class-id> <category>converting</category>

<body package="ChemoJun-Abstract-Objects" selector="asImage">asImage
	| aView anImage |
	aView := self getView.
	(aView isNil or: [aView isOpen not]) 
		ifTrue: [anImage := super asImage]
		ifFalse: 
			[self errorSignal handle: [:exception | anImage := super asImage]
				do: 
					[| aWindow aPixmap |
					aWindow := aView topComponent.
					aWindow isCollapsed ifTrue: [aWindow expand].
					aWindow raise.
					aWindow display.
					anImage := aWindow asImage.
					aPixmap := Pixmap extent: aView bounds extent.
					anImage displayOn: aPixmap graphicsContext
						at: (aView localPointToGlobal: 0 @ 0) negated.
					anImage := aPixmap asImage.
					aPixmap close]].
	^anImage</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunGeneralViewer</class-id> <category>displaying</category>

<body package="ChemoJun-Abstract-Objects" selector="displaySuperimposeInView:">displaySuperimposeInView: aView 
	| aGraphicsContext aBlock numberOfArbuments aCollection |
	self exceptIndex ifTrue: [^nil].
	aView isNil ifTrue: [^nil].
	aView isOpen ifFalse: [^nil].
	self moleculeObject isNil ifTrue: [^nil].
	aGraphicsContext := aView graphicsContext.
	aBlock := self indexExpressionBlock.
	numberOfArbuments := aBlock numArgs.
	aCollection := SortedCollection new: self numberOfAtoms.
	self atomObjectsAndIndexesDo: 
			[:atomObject :index | 
			true = (aBlock 
						valueWithArguments: ((Array 
								with: index
								with: atomObject atomicSymbol
								with: atomObject atomicPoint) copyFrom: 1 to: numberOfArbuments)) 
				ifTrue: 
					[| aText aPoint zValue |
					(atomObject isHydrogen and: [self exceptHydrogen]) 
						ifFalse: 
							[aText := index printString asText.
							aPoint := self convertModelPointToView3dPoint: atomObject atomicPoint
										in: aView bounds.
							zValue := aPoint z.
							aPoint := (aPoint x @ aPoint y) rounded.
							aCollection add: zValue -&gt; (Array with: aText with: aPoint)]]].
	aCollection reverseDo: 
			[:anAssociation | 
			| aText aPoint |
			aText := anAssociation value first.
			aPoint := anAssociation value last.
			aView 
				displayText: aText
				on: aGraphicsContext
				at: aPoint
				textColor: (ColorValue brightness: 0.05)
				vergeColor: (ColorValue brightness: 0.95)
				styleSymbol: #small
				alignmentSymbol: #center]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunGeneralViewer</class-id> <category>flushing</category>

<body package="ChemoJun-Abstract-Objects" selector="flushDisplayObject">flushDisplayObject
	^self</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunGeneralViewer</class-id> <category>menu accessing</category>

<body package="ChemoJun-Abstract-Objects" selector="updateFileMenuIndication">updateFileMenuIndication
	| menuItem aMenu displayObjectIsEmpty |
	super updateFileMenuIndication.
	menuItem := self menuItemLabeled: 'File' inMenu: self menuBar.
	menuItem isNil ifTrue: [^self].
	aMenu := menuItem submenu.
	aMenu isNil ifTrue: [^nil].
	displayObjectIsEmpty := self isEmpty.
	menuItem := self menuItemLabeled: 'Save as' asString inMenu: aMenu.
	menuItem notNil 
		ifTrue: 
			[displayObjectIsEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunGeneralViewer</class-id> <category>menu messages</category>

<body package="ChemoJun-Abstract-Objects" selector="requestNewImageFilename">requestNewImageFilename
	"ChemoJunGeneralViewer new requestNewImageFilename."

	| labels values menu message aFilename |
	labels := Array 
				with: (Array with: (#jun_Image_files &gt;&gt; 'Image files') asString).
	values := Array with: JunSystem defaultImageExtensionPatterns.
	menu := Menu labelList: labels values: values.
	message := #jun_Input_an_image_file_ &gt;&gt; 'Input an image file.' 
				expandMacrosWith: 'image'.
	aFilename := ChemoJunFileRequesterDialog 
				requestNewFilename: message
				initialFilename: self defaultBaseName , '.jpg'
				fileTypeMenu: menu
				initialFileType: values first.
	aFilename isNil ifTrue: [^nil].
	^aFilename</body>

<body package="ChemoJun-Abstract-Objects" selector="saveAsImage">saveAsImage
	| aBoolean anImage aFilename |
	aBoolean := JunSensorUtility shiftDown or: [JunSensorUtility altDown].
	anImage := self asImage.
	anImage isNil ifTrue: [^nil].
	aBoolean 
		ifTrue: 
			[anImage := anImage convertToPalette: JunImageProcessor grayPalette256
						renderedBy: NearestPaint new].
	aFilename := self requestNewImageFilename.
	aFilename isNil ifTrue: [^nil].
	self writeImage: anImage to: aFilename.
	^anImage</body>

<body package="ChemoJun-Abstract-Objects" selector="settingIndex">settingIndex
	| aStream aString |
	aStream := String new writeStream.
	aStream nextPutAll: (#chemoJun_Expression_ &gt;&gt; 'Expression?') asString.
	aStream cr.
	aStream nextPutAll: (#jun_ex_ &gt;&gt; 'ex.') asString , ')'.
	aStream cr.
	aStream nextPutAll: '[:index | true]'.
	aStream cr.
	aStream nextPutAll: '[:index | index odd]'.
	aStream cr.
	aStream nextPutAll: '[:index | index even]'.
	aStream cr.
	aStream nextPutAll: '[:index | (index \\ 3) = 1]'.
	aStream cr.
	aStream nextPutAll: '[:index | #(1 10 50 100 150 999) includes: index]'.
	aStream cr.
	aStream nextPutAll: '[:index :atom | atom = ''C'']'.
	aStream cr.
	aStream nextPutAll: '[:index :atom | (atom = ''H'') not]'.
	aStream cr.
	aStream nextPutAll: '[:index :atom | (index odd) &amp; (atom = ''C'')]'.
	aStream cr.
	aStream nextPutAll: '[:index :atom :point | false]'.
	aString := aStream contents.
	aStream close.
	aString := JunDialog request: aString initialAnswer: self indexExpression.
	aString isNil ifTrue: [^nil].
	aString isEmpty ifTrue: [^nil].
	self indexExpression: aString.
	self flushDisplayObject.
	self changed: #object</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunGeneralViewer</class-id> <category>preferences</category>

<body package="ChemoJun-Abstract-Objects" selector="chemoJunJapanese">chemoJunJapanese
	^self preferenceTable at: #chemoJunJapanese ifAbsentPut: [false]</body>

<body package="ChemoJun-Abstract-Objects" selector="chemoJunJapanese:">chemoJunJapanese: aBoolean 
	self preferenceTable at: #chemoJunJapanese put: aBoolean = true</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunGeneralViewer</class-id> <category>testing</category>

<body package="ChemoJun-Abstract-Objects" selector="isOpen">isOpen
	self getView ifNil: [^false] ifNotNil: [:aView | ^aView isOpen]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunGeneralViewer</class-id> <category>private</category>

<body package="ChemoJun-Abstract-Objects" selector="setIndexExpression:setIndexExpressionBlock:">setIndexExpression: aString setIndexExpressionBlock: aBlock 
	^self</body>
</methods>


</st-source>
