<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76978 "21:22:58"))'</do-it>



<class>
<name>ChemoJunGrapher</name>
<environment>ChemoJun</environment>
<super>Jun.JunGrapher</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Topology-Grapher</category>
<attributes>
<package>ChemoJun-Topology-Grapher</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunGrapher class</class-id> <category>copyright</category>

<body package="ChemoJun-Topology-Grapher" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Topology-Grapher" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Topology-Grapher" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunGrapher class</class-id> <category>examples</category>

<body package="ChemoJun-Topology-Grapher" selector="example1">example1
	"ChemoJunGrapher example1."

	| moleculeObject moleculeViewer chemGrapher |
	moleculeObject := ChemoJunMoleculeObject request.
	moleculeObject isNil ifTrue: [^nil].
	moleculeViewer := ChemoJunMoleculeViewer moleculeObject: moleculeObject.
	moleculeViewer openAt: 100 @ 250.
	chemGrapher := moleculeViewer asGrapher.
	chemGrapher openAt: 410 @ 250.
	^chemGrapher</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunGrapher class</class-id> <category>interface specs</category>

<body package="ChemoJun-Topology-Grapher" selector="windowSpec">windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 
			#(#{Kernel.UserMessage} 
				#key: #jun_Grapher 
				#defaultString: 'Grapher' ) 
			#min: #(#{Core.Point} 640 480 ) 
			#max: #(#{Core.Point} 0 0 ) 
			#bounds: #(#{Graphics.Rectangle} 0 0 640 480 ) 
			#colors: 
			#(#{UI.LookPreferences} 
				#setBackgroundColor: #(#{Graphics.ColorValue} 8000 8000 8000 ) ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.LayoutFrame} 1 0 1 0 -1 1 -1 1 ) 
					#name: #createView 
					#component: #createView ) ) ) )</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunGrapher</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunGrapher</class-id> <category>scrolling</category>

<body package="ChemoJun-Topology-Grapher" selector="scrollFor:">scrollFor: aNode 
	self isHierarchicalArrangement 
		ifTrue: 
			[self getView ifNotNil: 
					[:aView | 
					aView scrollTo: aNode bounds origin negated 
								+ self graph arrangeForestMargin asPoint.
					self
						focusBoundingBox: nil;
						focusBoundingBox]]
		ifFalse: [super scrollFor: aNode]</body>
</methods>


</st-source>
