<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76976 "21:22:56"))'</do-it>



<class>
<name>ChemoJunImageCatalogView</name>
<environment>ChemoJun</environment>
<super>UI.ScrollingView</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Catalog-Image</category>
<attributes>
<package>ChemoJun-Catalog-Image</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunImageCatalogView class</class-id> <category>copyright</category>

<body package="ChemoJun-Catalog-Image" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Catalog-Image" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Catalog-Image" selector="version">version
	^'071'
</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunImageCatalogView</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogView</class-id> <category>bounds accessing</category>

<body package="ChemoJun-Catalog-Image" selector="bounds:">bounds: newBounds 
	super bounds: newBounds.
	
	[| viewWidth imageWidth columnSize |
	self model isEmpty ifTrue: [^nil].
	viewWidth := self bounds width.
	imageWidth := self model elements first image width.
	columnSize := (viewWidth / imageWidth) floor.
	self model arrange: columnSize] 
			yourself</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogView</class-id> <category>controller accessing</category>

<body package="ChemoJun-Catalog-Image" selector="defaultControllerClass">defaultControllerClass
	^ChemoJunImageCatalogController</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogView</class-id> <category>display box accessing</category>

<body package="ChemoJun-Catalog-Image" selector="preferredBounds">preferredBounds
	self model isNil 
		ifTrue: [^Screen default bounds]
		ifFalse: [^self model boundingBox]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogView</class-id> <category>displaying</category>

<body package="ChemoJun-Catalog-Image" selector="displayOn:">displayOn: graphicsContext 
	self model displayOn: graphicsContext</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogView</class-id> <category>updating</category>

<body package="ChemoJun-Catalog-Image" selector="update:">update: aSymbol 
	self isOpen ifFalse: [^self].
	(#(#redisplay #clearAndRedisplay) includes: aSymbol) 
		ifTrue: 
			[aSymbol = #redisplay 
				ifTrue: 
					[self displayOn: self graphicsContext.
					self fixScrollingOffset].
			aSymbol = #clearAndRedisplay 
				ifTrue: 
					[self
						fixScrollingOffset;
						invalidateNow]]
		ifFalse: 
			[super update: aSymbol.
			self fixScrollingOffset]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogView</class-id> <category>private</category>

<body package="ChemoJun-Catalog-Image" selector="scrollOffset">scrollOffset
	^scrollOffset value</body>
</methods>


</st-source>
