<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76978 "21:22:58"))'</do-it>



<class>
<name>ChemoJunLauncher</name>
<environment>ChemoJun</environment>
<super>Jun.JunLauncher</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-System-Support</category>
<attributes>
<package>ChemoJun-System-Support</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunLauncher class</class-id> <category>class initialization</category>

<body package="ChemoJun-System-Support" selector="initialize">initialize
	"ChemoJunLauncher initialize."

	super initialize</body>

<body package="ChemoJun-System-Support" selector="install">install
	"ChemoJunLauncher install."

	"It is necessary to hook at installation."

	super install</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunLauncher class</class-id> <category>copyright</category>

<body package="ChemoJun-System-Support" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-System-Support" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-System-Support" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunLauncher class</class-id> <category>defaults</category>

<body package="ChemoJun-System-Support" selector="defaultSystemClass">defaultSystemClass
	^ChemoJunSystem</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunLauncher class</class-id> <category>examples</category>

<body package="ChemoJun-System-Support" selector="example1">example1
	"ChemoJunLauncher example1."

	ChemoJunLauncher open</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunLauncher class</class-id> <category>resources</category>

<body package="ChemoJun-System-Support" selector="menuBar">menuBar
	"Tools.MenuEditor new openOnClass: self andSelector: #menuBar"

	&lt;resource: #menu&gt;
	^#(#{UI.Menu} #(
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_Tools 
					#defaultString: 'Tools' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Molecular_Viewer 
								#defaultString: 'Molecular Viewer' ) 
							#value: #openMoleculeViewer ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Molecular_Viewer___Select_Data 
								#defaultString: 'Molecular Viewer - Select Data' ) 
							#value: #openMoleculeViewerData ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Chemical_Media_Navigator 
								#defaultString: 'Chemical Media Navigator' ) 
							#value: #openChemicalMediaNavigator ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Molecular_Image_Catalog 
								#defaultString: 'Molecular Image Catalog' ) 
							#value: #openMoleculeImageCatalog ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Molecular_Image_Catalog___Select_Data 
								#defaultString: 'Molecular Image Catalog - Select Data' ) 
							#value: #openMoleculeImageCatalogData ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Molecular_Viewer_Catalog 
								#defaultString: 'Molecular Viewer Catalog' ) 
							#value: #openMoleculeViewerCatalog ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Molecular_Viewer_Catalog___Select_Data 
								#defaultString: 'Molecular Viewer Catalog - Select Data' ) 
							#value: #openMoleculeViewerCatalogData ) ) #(2 1 2 2 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #jun_Misc 
					#defaultString: 'Misc' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Manual 
								#defaultString: 'Manual' ) 
							#value: #browseManual ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_About 
								#defaultString: 'About' ) 
							#value: #openAbout ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Credits 
								#defaultString: 'Credits' ) 
							#value: #openCredits ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Web_Page 
								#defaultString: 'Web Page' ) 
							#value: #openWebPage ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_E_mail 
								#defaultString: 'E-mail' ) 
							#value: #openEmail ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Jun_Launcher 
								#defaultString: 'Jun Launcher' ) 
							#value: #openJunLauncher ) ) #(1 4 1 ) nil ) ) ) #(2 ) nil ) decodeAsLiteralArray</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunLauncher</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunLauncher</class-id> <category>defaults</category>

<body package="ChemoJun-System-Support" selector="defaultWindowLabel">defaultWindowLabel
	^(#chemoJun_ChemoJun_Launcher &gt;&gt; 'ChemoJun Launcher') asString</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunLauncher</class-id> <category>menu messages</category>

<body package="ChemoJun-System-Support" selector="browseManual">browseManual
	| urlString junURL |
	urlString := ChemoJunUtility manualUriStringConstruct: 'index.html'.
	(junURL := JunURL named: urlString) exists 
		ifFalse: 
			[^JunDialog 
				warn: (#chemoJun__1p__does_not_exist_ &gt;&gt; '&lt;1p&gt; does not exist.' 
						expandMacrosWith: urlString)].
	junURL browse</body>

<body package="ChemoJun-System-Support" selector="changeFont">changeFont
	ChemoJunSystem changeFont</body>

<body package="ChemoJun-System-Support" selector="openAbout">openAbout
	ChemoJunSystem about</body>

<body package="ChemoJun-System-Support" selector="openChemicalMediaNavigator">openChemicalMediaNavigator
	ChemoJunChemicalMediaNavigator open</body>

<body package="ChemoJun-System-Support" selector="openCredits">openCredits
	ChemoJunCredits show</body>

<body package="ChemoJun-System-Support" selector="openEmail">openEmail
	JunURL 
		browse: (JunEnvironmentUtility environmentVariableAt: 'ChemoJunMailUri'
				ifAbsent: ['mailto:cheminfo@nii.ac.jp' yourself])</body>

<body package="ChemoJun-System-Support" selector="openJunLauncher">openJunLauncher
	JunLauncher install</body>

<body package="ChemoJun-System-Support" selector="openMoleculeImageCatalog">openMoleculeImageCatalog
	ChemoJunImageCatalog open</body>

<body package="ChemoJun-System-Support" selector="openMoleculeImageCatalogData">openMoleculeImageCatalogData
	| aCollection aPoint |
	JunSensorUtility shiftDown 
		ifTrue: 
			[aCollection := ChemoJunUtility selectDirectoriesInChemoJunSampleData 
						ifNil: [Array new]
						ifNotNil: [:it | it yourself]]
		ifFalse: 
			[aCollection := ChemoJunUtility selectDirectoryInChemoJunSampleData 
						ifNil: [Array new]
						ifNotNil: [:it | (Array with: it) yourself]].
	aPoint := 100 @ 100.
	aCollection do: 
			[:anAssociation | 
			| aBoolean aDirectory aCatalog |
			aBoolean := anAssociation key = #japanese.
			aDirectory := anAssociation value.
			aCatalog := (ChemoJunImageCatalog new)
						columnSize: 5;
						elementExtent: 128 @ 128;
						directory: aDirectory;
						yourself.
			aCatalog chemoJunJapanese: aBoolean.
			aCatalog openAt: aPoint.
			aPoint := aPoint + (20 @ 20).
			JunSensorUtility shiftDown ifTrue: [^self]]</body>

<body package="ChemoJun-System-Support" selector="openMoleculeViewer">openMoleculeViewer
	ChemoJunMoleculeViewer open</body>

<body package="ChemoJun-System-Support" selector="openMoleculeViewerCatalog">openMoleculeViewerCatalog
	ChemoJunViewerCatalog open</body>

<body package="ChemoJun-System-Support" selector="openMoleculeViewerCatalogData">openMoleculeViewerCatalogData
	| aCollection aPoint |
	JunSensorUtility shiftDown 
		ifTrue: 
			[aCollection := ChemoJunUtility selectDirectoriesInChemoJunSampleData 
						ifNil: [Array new]
						ifNotNil: [:it | it yourself]]
		ifFalse: 
			[aCollection := ChemoJunUtility selectDirectoryInChemoJunSampleData 
						ifNil: [Array new]
						ifNotNil: [:it | (Array with: it) yourself]].
	aPoint := 100 @ 100.
	aCollection do: 
			[:anAssociation | 
			| aBoolean aDirectory aCatalog |
			aBoolean := anAssociation key = #japanese.
			aDirectory := anAssociation value.
			aCatalog := ChemoJunViewerCatalog directory: aDirectory.
			aCatalog openAt: aPoint.
			aCatalog chemoJunJapanese: aBoolean.
			aCatalog updateViewers.
			aPoint := aPoint + (20 @ 20).
			JunSensorUtility shiftDown ifTrue: [^self]]</body>

<body package="ChemoJun-System-Support" selector="openMoleculeViewerData">openMoleculeViewerData
	| aCollection aPoint |
	JunSensorUtility shiftDown 
		ifTrue: 
			[aCollection := ChemoJunUtility selectMolfilesInChemoJunSampleData 
						ifNil: [Array new]
						ifNotNil: [:it | it yourself]]
		ifFalse: 
			[aCollection := ChemoJunUtility selectMolfileInChemoJunSampleData 
						ifNil: [Array new]
						ifNotNil: [:it | (Array with: it) yourself]].
	aPoint := 100 @ 100.
	aCollection do: 
			[:anAssociation | 
			| aBoolean aFilename aViewer |
			aBoolean := anAssociation key = #japanese.
			aFilename := anAssociation value.
			aViewer := ChemoJunMoleculeViewer fileName: aFilename.
			aViewer chemoJunJapanese: aBoolean.
			aViewer openAt: aPoint.
			aPoint := aPoint + (20 @ 20).
			JunSensorUtility shiftDown ifTrue: [^self]]</body>

<body package="ChemoJun-System-Support" selector="openWebPage">openWebPage
	JunURL 
		browse: (JunEnvironmentUtility environmentVariableAt: 'ChemoJunWebPageUri'
				ifAbsent: ['http://research.nii.ac.jp/~cheminfo/ChemoJun/' yourself])</body>
</methods>

<initialize>
<class-id>ChemoJun.ChemoJunLauncher</class-id>
</initialize>


</st-source>
