<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76978 "21:22:58"))'</do-it>



<class>
<name>ChemoJunViewerCatalogViewer</name>
<environment>ChemoJun</environment>
<super>ChemoJun.ChemoJunMoleculeModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>moleculeCatalog yellowButtonMenu </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Catalog-Viewer</category>
<attributes>
<package>ChemoJun-Catalog-Viewer</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogViewer class</class-id> <category>copyright</category>

<body package="ChemoJun-Catalog-Viewer" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Catalog-Viewer" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Catalog-Viewer" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogViewer class</class-id> <category>resources</category>

<body package="ChemoJun-Catalog-Viewer" selector="yellowButtonMenu">yellowButtonMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #yellowButtonMenu"

	&lt;resource: #menu&gt;
	^#(#{UI.Menu} #(
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_Open_Molecular_Viewer 
					#defaultString: 'Open Molecular Viewer' ) 
				#value: #openMoleculeViewer ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_2D 
					#defaultString: '2D' ) 
				#value: #showMoleculeAsPlane ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_Sticks 
					#defaultString: 'Sticks' ) 
				#value: #showMoleculeAsStick ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_Ball_and_Stick 
					#defaultString: 'Ball &amp;&amp; Stick' ) 
				#value: #showMoleculeAsBallAndStick ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_Space_Filling 
					#defaultString: 'Space Filling' ) 
				#value: #showMoleculeAsSpaceFill ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_Stick_and_Space_Filling 
					#defaultString: 'Stick &amp;&amp; Space Filling' ) 
				#value: #showMoleculeAsStickAndSpaceFill ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_Show_Hydrogens 
					#defaultString: 'Hydrogens' ) 
				#value: #toggleHydrogen ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_Show_Serial_Nos__of_Atoms 
					#defaultString: 'Serial Nos. of Atoms' ) 
				#value: #toggleIndex ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_Setting_Serial_Nos_ 
					#defaultString: 'Setting Serial Nos.' ) 
				#value: #settingIndex ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #jun_Reset 
					#defaultString: 'Reset' ) 
				#value: #resetView ) ) #(1 5 3 1 ) nil ) decodeAsLiteralArray</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunViewerCatalogViewer</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogViewer</class-id> <category>initialize-release</category>

<body package="ChemoJun-Catalog-Viewer" selector="initialize">initialize
	super initialize.
	moleculeCatalog := nil.
	yellowButtonMenu := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogViewer</class-id> <category>accessing</category>

<body package="ChemoJun-Catalog-Viewer" selector="catalogElement">catalogElement
	| index catalogElement |
	self moleculeCatalog ifNil: [^nil].
	index := self moleculeCatalog viewers indexOf: self.
	index := self moleculeCatalog startIndex + index - 1.
	index &gt; self moleculeCatalog elements size ifTrue: [^nil].
	catalogElement := self moleculeCatalog elements at: index.
	^catalogElement</body>

<body package="ChemoJun-Catalog-Viewer" selector="moleculeCatalog">moleculeCatalog
	^moleculeCatalog</body>

<body package="ChemoJun-Catalog-Viewer" selector="moleculeCatalog:">moleculeCatalog: aMoleculeCatalog 
	(moleculeCatalog := aMoleculeCatalog) 
		ifNotNil: [self chemoJunJapanese: aMoleculeCatalog chemoJunJapanese]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogViewer</class-id> <category>actions</category>

<body package="ChemoJun-Catalog-Viewer" selector="clickAt:">clickAt: mouse2dPoint 
	self moleculeCatalog ifNotNil: [:it | it selectViewer: self]</body>

<body package="ChemoJun-Catalog-Viewer" selector="doubleClickAt:">doubleClickAt: mouse2dPoint 
	self openMoleculeViewer</body>

<body package="ChemoJun-Catalog-Viewer" selector="moveAt:">moveAt: mouse2dPoint 
	self moleculeCatalog ifNotNil: [:it | it moveElement: self]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogViewer</class-id> <category>defaults</category>

<body package="ChemoJun-Catalog-Viewer" selector="defaultDisplayViewClass">defaultDisplayViewClass
	^ChemoJunViewerCatalogViewerView</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogViewer</class-id> <category>displaying</category>

<body package="ChemoJun-Catalog-Viewer" selector="displaySuperimposeCatalogIndexInView:">displaySuperimposeCatalogIndexInView: aView 
	| catalogIndex composedText |
	self moleculeCatalog ifNil: [^nil].
	self moleculeCatalog visibleCatalogIndex ifFalse: [^nil].
	self moleculeObject ifNil: [^nil].
	catalogIndex := self moleculeCatalog elements 
				findFirst: [:element | element moleculeObject = self moleculeObject].
	catalogIndex &lt; 1 ifTrue: [^nil].
	composedText := ComposedText withText: catalogIndex printString
				style: TextAttributes default.
	self 
		displayComposedText: composedText
		on: aView graphicsContext
		at: aView bounds topLeft
		textColor: ColorValue blue
		vergeColor: ColorValue white
		alignmentSymbol: #topLeft</body>

<body package="ChemoJun-Catalog-Viewer" selector="displaySuperimposeFileNameInView:">displaySuperimposeFileNameInView: aView 
	| aString aStyle composedText |
	self moleculeCatalog ifNil: [^nil].
	self moleculeCatalog visibleFileName ifFalse: [^nil].
	self moleculeObject ifNil: [^nil].
	self moleculeObject fileName ifNil: [^nil].
	aString := (Filename splitPath: self moleculeObject fileName asString) 
				last.
	aString ifNil: [^nil].
	aString := (Filename splitExtension: aString) first.
	aString ifNil: [^nil].
	self chemoJunJapanese 
		ifTrue: 
			[(ChemoJunUtility 
				japaneseMolfileName: self moleculeObject fileName asString) 
					ifNotNil: [:japaneseMolfileName | aString := japaneseMolfileName]].
	aStyle := TextAttributes styleNamed: #default
				ifAbsent: [TextAttributes default].
	composedText := ComposedText withText: aString asText style: aStyle.
	composedText bounds width &gt; aView bounds width 
		ifTrue: 
			[composedText := ComposedText 
						withText: aString
						style: TextAttributes default
						compositionWidth: aView bounds width].
	self 
		displayComposedText: composedText
		on: aView graphicsContext
		at: aView bounds bottomRight
		textColor: ColorValue black
		vergeColor: ColorValue white
		alignmentSymbol: #bottomRight</body>

<body package="ChemoJun-Catalog-Viewer" selector="displaySuperimposeInView:">displaySuperimposeInView: aView 
	super displaySuperimposeInView: aView.
	self
		displaySuperimposeFileNameInView: aView;
		displaySuperimposeCatalogIndexInView: aView</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogViewer</class-id> <category>menu accessing</category>

<body package="ChemoJun-Catalog-Viewer" selector="updateMenuIndication">updateMenuIndication
	super updateMenuIndication.
	self updateYellowButtonMenuIndication</body>

<body package="ChemoJun-Catalog-Viewer" selector="updateViewMenuIndication">updateViewMenuIndication
	super updateViewMenuIndication.
	self updateYellowButtonMenuIndication</body>

<body package="ChemoJun-Catalog-Viewer" selector="updateYellowButtonMenuIndication">updateYellowButtonMenuIndication
	| aMenu menuItem |
	aMenu := self yellowButtonMenu.
	aMenu notNil 
		ifTrue: 
			[menuItem := aMenu menuItemWithValue: #showMoleculeAsPlane ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self messageSymbol = #moleculeAsPlane 
						ifTrue: [menuItem beOn]
						ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #showMoleculeAsStick ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self messageSymbol = #moleculeAsStick 
						ifTrue: [menuItem beOn]
						ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #showMoleculeAsBallAndStick
						ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self messageSymbol = #moleculeAsBallAndStick 
						ifTrue: [menuItem beOn]
						ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #showMoleculeAsSpaceFill ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self messageSymbol = #moleculeAsSpaceFill 
						ifTrue: [menuItem beOn]
						ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #showMoleculeAsStickAndSpaceFill
						ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self messageSymbol = #moleculeAsStickAndSpaceFill 
						ifTrue: [menuItem beOn]
						ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #toggleHydrogen ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self exceptHydrogen ifTrue: [menuItem beOff] ifFalse: [menuItem beOn].
					self messageSymbol = #moleculeAsSpaceFill ifTrue: [menuItem disable]].
			menuItem := aMenu menuItemWithValue: #toggleIndex ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self exceptIndex ifTrue: [menuItem beOff] ifFalse: [menuItem beOn].
					self messageSymbol = #moleculeAsSpaceFill ifTrue: [menuItem disable]].
			menuItem := aMenu menuItemWithValue: #settingIndex ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[self exceptIndex ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #resetView ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[self moleculeObject isNil 
						ifTrue: [menuItem disable]
						ifFalse: [menuItem enable]]]</body>

<body package="ChemoJun-Catalog-Viewer" selector="yellowButtonMenu">yellowButtonMenu
	self displayObject ifNil: [^nil].
	yellowButtonMenu ifNil: [yellowButtonMenu := self class yellowButtonMenu].
	^yellowButtonMenu</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogViewer</class-id> <category>menu messages</category>

<body package="ChemoJun-Catalog-Viewer" selector="openMoleculeViewer">openMoleculeViewer
	| aViewer |
	self moleculeObject ifNil: [^nil].
	self moleculeCatalog ifNil: [^nil].
	aViewer := ChemoJunMoleculeViewer new.
	self getView ifNil: [aViewer open]
		ifNotNil: 
			[:aView | 
			| aPoint aBox |
			aPoint := (aView bounds width / aView bounds height) @ 1.
			aBox := 0 @ 0 extent: (self class windowBounds extent * aPoint) rounded.
			aPoint := (aView localPointToGlobal: aView bounds center) 
						translatedBy: aView topComponent globalOrigin.
			aBox := aBox align: aBox center with: aPoint.
			aViewer openIn: aBox].
	self catalogElement applyPreferencesTo: aViewer.
	aViewer defaultProjectionTable: self defaultProjectionTable.
	aViewer projectionTable: self projectionTable.
	aViewer cameraButton compute: 
			[:value | 
			self moleculeCatalog 
				pressedCameraButtonOf: self catalogElement
				in: aViewer
				from: self].
	aViewer beVisibleCameraButton</body>

<body package="ChemoJun-Catalog-Viewer" selector="resetView">resetView
	super resetView.
	self applyProjectionTableToElement</body>

<body package="ChemoJun-Catalog-Viewer" selector="showMoleculeAsBallAndStick">showMoleculeAsBallAndStick
	super showMoleculeAsBallAndStick.
	self applyMoleculePresentationToElement</body>

<body package="ChemoJun-Catalog-Viewer" selector="showMoleculeAsPlane">showMoleculeAsPlane
	super showMoleculeAsPlane.
	self applyMoleculePresentationToElement</body>

<body package="ChemoJun-Catalog-Viewer" selector="showMoleculeAsSpaceFill">showMoleculeAsSpaceFill
	super showMoleculeAsSpaceFill.
	self applyMoleculePresentationToElement</body>

<body package="ChemoJun-Catalog-Viewer" selector="showMoleculeAsStick">showMoleculeAsStick
	super showMoleculeAsStick.
	self applyMoleculePresentationToElement</body>

<body package="ChemoJun-Catalog-Viewer" selector="showMoleculeAsStickAndSpaceFill">showMoleculeAsStickAndSpaceFill
	super showMoleculeAsStickAndSpaceFill.
	self applyMoleculePresentationToElement</body>

<body package="ChemoJun-Catalog-Viewer" selector="toggleHydrogen">toggleHydrogen
	super toggleHydrogen.
	self applyExceptHydrogenToElement</body>

<body package="ChemoJun-Catalog-Viewer" selector="toggleIndex">toggleIndex
	super toggleIndex.
	self applyExceptIndexToElement</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogViewer</class-id> <category>preferences</category>

<body package="ChemoJun-Catalog-Viewer" selector="chemoJunJapanese">chemoJunJapanese
	^self preferenceTable at: #chemoJunJapanese ifAbsentPut: [false]</body>

<body package="ChemoJun-Catalog-Viewer" selector="chemoJunJapanese:">chemoJunJapanese: aBoolean 
	self preferenceTable at: #chemoJunJapanese put: aBoolean = true</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogViewer</class-id> <category>private</category>

<body package="ChemoJun-Catalog-Viewer" selector="applyExceptHydrogenToElement">applyExceptHydrogenToElement
	self moleculeCatalog ifNotNil: 
			[:aCatalog | 
			(aCatalog elementOfViewer: self) 
				ifNotNil: [:anElement | anElement exceptHydrogen: self exceptHydrogen]]</body>

<body package="ChemoJun-Catalog-Viewer" selector="applyExceptIndexToElement">applyExceptIndexToElement
	self moleculeCatalog ifNotNil: 
			[:aCatalog | 
			(aCatalog elementOfViewer: self) 
				ifNotNil: [:anElement | anElement exceptIndex: self exceptIndex]]</body>

<body package="ChemoJun-Catalog-Viewer" selector="applyMoleculePresentationToElement">applyMoleculePresentationToElement
	self moleculeCatalog ifNotNil: 
			[:aCatalog | 
			(aCatalog elementOfViewer: self) 
				ifNotNil: [:anElement | anElement moleculePresentation: self messageSymbol]]</body>

<body package="ChemoJun-Catalog-Viewer" selector="applyProjectionTableToElement">applyProjectionTableToElement
	self moleculeCatalog ifNotNil: 
			[:aCatalog | 
			(aCatalog elementOfViewer: self) 
				ifNotNil: [:anElement | anElement projectionTable: self projectionTable]]</body>
</methods>


</st-source>
